## libsml 0.1.1%2Bgit20170608

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_COMMIT='a83ec40d960eb334faf381a9c92aa884da8c3475'
REPACK_TEMPDIR:=$(shell mktemp -d)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

get-orig-source:
	wget https://github.com/volkszaehler/libsml/archive/$(UPSTREAM_COMMIT).tar.gz -O $(REPACK_TEMPDIR)/libsml_$(DEB_VERSION_UPSTREAM).tar.gz
	mkdir $(REPACK_TEMPDIR)/libsml-$(DEB_VERSION_UPSTREAM)
	tar -xvf $(REPACK_TEMPDIR)/libsml_$(DEB_VERSION_UPSTREAM).tar.gz --strip 1 -C $(REPACK_TEMPDIR)/libsml-$(DEB_VERSION_UPSTREAM)
	rm $(REPACK_TEMPDIR)/libsml_$(DEB_VERSION_UPSTREAM).tar.gz
	GZIP="--best --no-name" tar -czf $(REPACK_TEMPDIR)/libsml_$(DEB_VERSION_UPSTREAM).orig.tar.gz --exclude=CONTRIBUTION.pdf -C $(REPACK_TEMPDIR) libsml-$(DEB_VERSION_UPSTREAM)
	mv $(REPACK_TEMPDIR)/libsml_$(DEB_VERSION_UPSTREAM).orig.tar.gz $(CURDIR)

## libsml 0.1.1+git20170608

=== Makefile ===

all:
	@$(MAKE) -C sml
	@$(MAKE) -C examples
	@$(MAKE) -C test

.PHONY: clean
clean :
	@$(MAKE) -C sml clean
	@$(MAKE) -C examples clean
	@$(MAKE) -C test clean

=== examples/Makefile ===
UNAME := $(shell uname)
CFLAGS += -I../sml/include/ -g -std=c99 -Wall -Wextra -pedantic
OBJS = sml_server.o
LIBSML = ../sml/lib/libsml.a

ifeq ($(UNAME), Linux)
LIBS = -luuid
endif

sml_server : $(OBJS) $(LIBSML)
	$(CC) $(CFLAGS) $(OBJS) $(LIBS) $(LIBSML) -o sml_server $(LIBS)

%.o : %.c
	$(CC) $(CFLAGS) -c $^ -o $@

.PHONY: clean
clean:
	@rm -f *.o
	@rm -f sml_server

=== sml/Makefile ===
UNAME := $(shell uname)
CFLAGS += -I./include/ -fPIC -fno-stack-protector -g -std=c99 -Wall -Wextra -pedantic

# Available Flags:
# SML_NO_UUID_LIB - compile without uuid lib

ifeq ($(UNAME), Linux)
LIBS=-luuid
endif

NAME=libsml
SOVERSION=1
SONAME=$(NAME).so.$(SOVERSION)

LIB_DIR=./lib
OBJ_LIB=$(LIB_DIR)/$(NAME).o
DYN_LIB=$(LIB_DIR)/$(SONAME)
ST_LIB=$(LIB_DIR)/$(NAME).a

OBJS = \
	src/sml_file.o \
	src/sml_attention_response.o \
	src/sml_transport.o \
	src/sml_octet_string.o \
	src/sml_shared.o \
	src/sml_number.o \
	src/sml_message.o \
	src/sml_time.o \
	src/sml_list.o \
	src/sml_status.o \
	src/sml_value.o \
	src/sml_tree.o \
	src/sml_boolean.o \
	src/sml_crc16.o \
	src/sml_open_request.o \
	src/sml_open_response.o \
	src/sml_get_list_request.o \
	src/sml_get_list_response.o \
	src/sml_close_request.o \
	src/sml_close_response.o \
	src/sml_set_proc_parameter_request.o \
	src/sml_get_proc_parameter_request.o \
	src/sml_get_proc_parameter_response.o \
	src/sml_get_profile_pack_request.o \
	src/sml_get_profile_pack_response.o \
	src/sml_get_profile_list_request.o \
	src/sml_get_profile_list_response.o

ifeq ($(UNAME), Linux)
libsml: $(DYN_LIB) $(ST_LIB) $(OBJ_LIB)
endif
ifeq ($(UNAME), Darwin)
libsml: $(ST_LIB) $(OBJ_LIB)
endif

$(DYN_LIB): $(OBJS)
	$(LD) $(LIBS) -shared -soname $(SONAME) -o $@ $^

$(OBJ_LIB): $(OBJS)
	$(LD) -r -o $@ $^

$(ST_LIB): $(OBJS)
	$(AR) -rs $@ $^

.PHONY: clean
clean:
	@rm -f src/*.o
	@rm -f $(DYN_LIB) $(OBJ_LIB) $(ST_LIB)

=== test/Makefile ===
UNAME := $(shell uname)
CFLAGS += -I../sml/include/ -std=c99 -Wall -Wextra -pedantic
LIBSML = ../sml/lib/libsml.a

ifeq ($(UNAME), Linux)
LIBS = -luuid
endif

UNITY = \
	unity/unity.o \
	unity/unity_fixture.o

OBJS = \
	src/test_helper.o \
	src/sml_octet_string_test.o \
	src/sml_buffer_test.o \
	src/sml_number_test.o \
	src/sml_boolean_test.o \
	src/sml_value_test.o \
	src/sml_status_test.o \
	src/sml_list_test.o \
	src/sml_time_test.o \
	src/sml_tree_test.o \
	src/sml_file_test.o \
	src/sml_open_request_test.o \
	src/sml_get_profile_pack_request_test.o \
	src/sml_message_test.o

test_run: libsml test
	@./test

test : $(UNITY) $(OBJS) $(LIBSML)
	$(CC) $(CFLAGS) $(LIBS) $^ test_main.c -o test $(LIBS)

.PHONY: code
libsml : 
	@$(MAKE) -C ../sml

%.o : %.c
	$(CC) $(CFLAGS) -c $^ -o $@

.PHONY: clean
clean :
	@rm -f unity/*.o
	@rm -f src/*.o
	@rm -f test

## libsml 0.1.1%2Bgit20180125

=== debian/control ===
Source: libsml
Priority: optional
Maintainer: Andreas Moog <andreas.moog@warperbbs.de>
Build-Depends: debhelper (>= 11~), uuid-dev (>= 2.16), dh-exec
Standards-Version: 4.1.4
Section: libs
Homepage: https://github.com/dailab/libsml
Vcs-Git: https://salsa.debian.org/amoog-guest/libsml.git
Vcs-Browser: https://salsa.debian.org/amoog-guest/libsml

Package: libsml-dev
Section: libdevel
Architecture: any
Depends: libsml1 (= ${binary:Version}), uuid-dev (>= 2.16), ${misc:Depends}
Description: Header files for libSML
 libSML is a library which implements the Smart Messaging Language (SML)
 protocol specified by VDE's Forum Netztechnik/Netzbetrieb (FNN).
 It can be utilized to communicate to FNN specified Smart Meters
 or Smart Meter components (EDL/MUC).
 .
 This package includes header include files and an example for libSML

Package: libsml1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Library for the Smart Messaging Language (SML)
 libSML is a library which implements the Smart Messaging Language (SML)
 protocol specified by VDE's Forum Netztechnik/Netzbetrieb (FNN).
 It can be utilized to communicate to FNN specified Smart Meters
 or Smart Meter components (EDL/MUC).

## libsml 0.1.1+git20170608

=== debian/changelog ===
libsml (0.1.1+git20170608-2) unstable; urgency=medium

  * Add patch to allow building on non-Linux. (Closes: #873895)
  * Use O_NONBLOCK where available (Closes: #873894)
  * Declare compatibility with Policy 4.1.0

 -- Andreas Moog <andreas.moog@warperbbs.de>  Sat, 16 Sep 2017 14:19:47 +0200

libsml (0.1.1+git20170608-1) unstable; urgency=medium

  * Initial release. (Closes: #864314)

 -- Andreas Moog <andreas.moog@warperbbs.de>  Thu, 08 Jun 2017 20:17:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: libsml
 Priority: optional
 Maintainer: Andreas Moog <andreas.moog@warperbbs.de>
-Build-Depends: debhelper (>= 11~), uuid-dev (>= 2.16), dh-exec
-Standards-Version: 4.1.4
+Build-Depends: debhelper (>= 10~), uuid-dev (>= 2.16), dh-exec
+Standards-Version: 4.1.0
 Section: libs
-Homepage: https://github.com/dailab/libsml
-Vcs-Git: https://salsa.debian.org/amoog-guest/libsml.git
-Vcs-Browser: https://salsa.debian.org/amoog-guest/libsml
+Homepage: http://github.com/dailab/libsml
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/libsml.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/libsml.git;a=summary
 
 Package: libsml-dev
 Section: libdevel

=== debian/watch ===
version=4
opts=uversionmangle=s/^\./0\./ \
https://github.com/dailab/libsml/releases	.*\/v?(\d*\.\d*.*)\.tar\.gz

## libsml 0.1.1+git20180125

=== examples/Makefile ===
UNAME := $(shell uname)
CFLAGS += -I../sml/include/ -g -std=c99 -Wall -Wextra -pedantic
OBJS = sml_server.o
LIBSML = ../sml/lib/libsml.a
INSTALL = /usr/bin/install
prefix = /usr/local
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include

LIBS = -lm
ifneq ($(UNAME), Darwin)
LIBS += -luuid
endif

all: sml_server

sml_server: $(OBJS) $(LIBSML)
	$(CC) $(OBJS) $(LIBSML) $(LIBS) -o sml_server

%.o: %.c
	$(CC) $(CFLAGS) -c $^ -o $@

.PHONY: clean install uninstall
clean:
	@rm -f *.o
	@rm -f sml_server

install: sml_server
	$(INSTALL) sml_server $(bindir)

uninstall:
	@rm -f $(bindir)/sml_server

=== sml/Makefile ===
--- 
+++ 
@@ -4,18 +4,30 @@
 # Available Flags:
 # SML_NO_UUID_LIB - compile without uuid lib
 
-ifeq ($(UNAME), Linux)
+ifneq ($(UNAME), Darwin)
 LIBS=-luuid
 endif
 
 NAME=libsml
 SOVERSION=1
+ifeq ($(UNAME), Darwin)
+SONAME=$(NAME).$(SOVERSION).dylib
+else
 SONAME=$(NAME).so.$(SOVERSION)
+endif
 
 LIB_DIR=./lib
+INC_DIR=./include
 OBJ_LIB=$(LIB_DIR)/$(NAME).o
 DYN_LIB=$(LIB_DIR)/$(SONAME)
 ST_LIB=$(LIB_DIR)/$(NAME).a
+
+INSTALL = /usr/bin/install
+prefix = /usr/local
+exec_prefix = ${prefix}
+bindir = ${exec_prefix}/bin
+libdir = ${exec_prefix}/lib
+includedir = ${prefix}/include
 
 OBJS = \
 	src/sml_file.o \
@@ -46,15 +58,16 @@
 	src/sml_get_profile_list_request.o \
 	src/sml_get_profile_list_response.o
 
-ifeq ($(UNAME), Linux)
+all: libsml
+
 libsml: $(DYN_LIB) $(ST_LIB) $(OBJ_LIB)
-endif
-ifeq ($(UNAME), Darwin)
-libsml: $(ST_LIB) $(OBJ_LIB)
-endif
 
 $(DYN_LIB): $(OBJS)
+ifeq ($(UNAME), Darwin)
+	$(CC) $(LIBS) -dynamiclib -install_name $(SONAME) -o $@ $^
+else
 	$(LD) $(LIBS) -shared -soname $(SONAME) -o $@ $^
+endif
 
 $(OBJ_LIB): $(OBJS)
 	$(LD) -r -o $@ $^
@@ -62,8 +75,20 @@
 $(ST_LIB): $(OBJS)
 	$(AR) -rs $@ $^
 
-.PHONY: clean
+.PHONY: clean install uninstall
 clean:
 	@rm -f src/*.o
 	@rm -f $(DYN_LIB) $(OBJ_LIB) $(ST_LIB)
 
+install: $(DYN_LIB) $(ST_LIB)
+	$(INSTALL) $(DYN_LIB) $(ST_LIB) $(libdir)
+ifeq ($(UNAME), Darwin)
+	@cd $(libdir); ln -sf $(SONAME) $(NAME).dylib
+else
+	@cd $(libdir); ln -sf $(SONAME) $(NAME).so
+endif
+	cp -a $(INC_DIR)/* $(includedir)
+
+uninstall:
+	@rm -f $(libdir)/$(SONAME) $(libdir)/$(NAME).so $(libdir)/$(NAME).dylib $(libdir)/$(NAME).a
+	@rm -rf $(includedir)/sml

=== debian/changelog ===
libsml (0.1.1+git20180125-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch from Logan Rosen for FTBFS with gcc 10.
    (Closes: #957478)

 -- Adrian Bunk <bunk@debian.org>  Sun, 07 Feb 2021 00:09:04 +0200

libsml (0.1.1+git20180125-1) unstable; urgency=medium

  * New upstream release
  * Update VCS-Uri to salsa
  * Install pkg-config file to multiarch directory
  * Use dh-compat level 11
  * Declare compliance with Policy 4.1.4
  * Update copyright years
  * Use uscan and Files-Excluded instead of get-orig-source
  * Add gitlab CI

 -- Andreas Moog <andreas.moog@warperbbs.de>  Sun, 13 May 2018 10:27:20 +0200

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0.1.1+git%cd" \
https://github.com/volkszaehler/libsml \
HEAD debian uupdate

## libsml 1.1.0

=== Makefile ===
UNAME := $(shell uname)
CFLAGS += -I../sml/include/ -g -std=c99 -Wall -Wextra -pedantic
OBJS = sml_server.o
LIBSML = ../sml/lib/libsml.a
INSTALL = /usr/bin/install
prefix = /usr/local
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include

LIBS = -lm
ifneq ($(UNAME), Darwin)
LIBS += -luuid
endif

all: sml_server

sml_server: $(OBJS) $(LIBSML)
	$(CC) $(OBJS) $(LIBSML) $(LIBS) -o sml_server

%.o: %.c
	$(CC) $(CFLAGS) -c $^ -o $@

.PHONY: clean install uninstall
clean:
	@rm -f *.o
	@rm -f sml_server

install: sml_server
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) sml_server $(DESTDIR)$(bindir)

uninstall:
	@rm -f $(DESTDIR)$(bindir)/sml_server

=== debian/changelog ===
libsml (1.1.0-1) unstable; urgency=medium

  * New Upstream release
  * Changed to not require root during build

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Thu, 03 Aug 2023 06:12:50 +0200

libsml (1.0.2-3) unstable; urgency=medium

  * Fixed Vcs-Git branch syntax 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Fri, 14 Jul 2023 09:31:22 +0200

libsml (1.0.2-2) unstable; urgency=medium

  * Added watch file and improved Vcs-* attributes 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Thu, 13 Jul 2023 12:34:20 +0200

libsml (1.0.2-1) unstable; urgency=medium

  * Actually releases the fix that (Closes: #946525), see below.
  * Maintainer changed (Closes: #1034250) 
  * Moved to the volkszaehler repo 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Mon, 10 Jul 2023 10:44:57 +0200

libsml (0.1.1+git20191213-1) UNRELEASED; urgency=medium

  * New upstream snapshot
  * Update symbols file, some (erroneously exported) symbols are gone
  * Add comments to rules
  * Update copyright years
  * Change to correct github upstream project in debian/copyright
  * Update homepage to https://github.com/volkszaehler/libsml (Closes: #946525)
  * Update gitlab CI
  * Update standards version

 -- Andreas Moog <andreas.moog@warperbbs.de>  Sun, 17 Feb 2019 13:00:21 +0100

## libsml 1.1.2

=== Makefile ===
UNAME := $(shell uname)
CFLAGS += -I./include/ -fPIC -fno-stack-protector -g -std=c99 -Wall -Wextra -pedantic

# Available Flags:
# SML_NO_UUID_LIB - compile without uuid lib

ifneq ($(UNAME), Darwin)
LIBS=-luuid
endif

NAME=libsml
SOVERSION=1
ifeq ($(UNAME), Darwin)
SONAME=$(NAME).$(SOVERSION).dylib
else
SONAME=$(NAME).so.$(SOVERSION)
endif

LDFLAGS += -Wl,-soname=$(SONAME) -shared

LIB_DIR=./lib
INC_DIR=./include
OBJ_LIB=$(LIB_DIR)/$(NAME).o
DYN_LIB=$(LIB_DIR)/$(SONAME)
ST_LIB=$(LIB_DIR)/$(NAME).a

INSTALL = /usr/bin/install
prefix = /usr/local
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include

OBJS = \
	src/sml_file.o \
	src/sml_attention_response.o \
	src/sml_transport.o \
	src/sml_octet_string.o \
	src/sml_shared.o \
	src/sml_number.o \
	src/sml_message.o \
	src/sml_time.o \
	src/sml_list.o \
	src/sml_status.o \
	src/sml_value.o \
	src/sml_tree.o \
	src/sml_boolean.o \
	src/sml_crc16.o \
	src/sml_open_request.o \
	src/sml_open_response.o \
	src/sml_get_list_request.o \
	src/sml_get_list_response.o \
	src/sml_close_request.o \
	src/sml_close_response.o \
	src/sml_set_proc_parameter_request.o \
	src/sml_get_proc_parameter_request.o \
	src/sml_get_proc_parameter_response.o \
	src/sml_get_profile_pack_request.o \
	src/sml_get_profile_pack_response.o \
	src/sml_get_profile_list_request.o \
	src/sml_get_profile_list_response.o

all: libsml

libsml: $(DYN_LIB) $(ST_LIB) $(OBJ_LIB)

$(DYN_LIB): $(OBJS)
ifeq ($(UNAME), Darwin)
	$(CC) $(LIBS) -dynamiclib -install_name $(SONAME) -o $@ $^
else
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
endif

$(OBJ_LIB): $(OBJS)
	$(LD) -r -o $@ $^

$(ST_LIB): $(OBJS)
	$(AR) -rs $@ $^

.PHONY: clean install uninstall
clean:
	@rm -f src/*.o
	@rm -f $(DYN_LIB) $(OBJ_LIB) $(ST_LIB)

install: $(DYN_LIB) $(ST_LIB)
	install -d $(DESTDIR)$(libdir)
	$(INSTALL) $(DYN_LIB) $(ST_LIB) $(DESTDIR)$(libdir)
ifeq ($(UNAME), Darwin)
	@cd $(DESTDIR)$(libdir); ln -sf $(SONAME) $(NAME).dylib
else
	@cd $(DESTDIR)$(libdir); ln -sf $(SONAME) $(NAME).so
endif
	install -d $(DESTDIR)$(includedir)
	cp -a $(INC_DIR)/* $(DESTDIR)$(includedir)

uninstall:
	@rm -f $(DESTDIR)$(libdir)/$(SONAME) $(DESTDIR)$(libdir)/$(NAME).so $(DESTDIR)$(libdir)/$(NAME).dylib $(DESTDIR)$(libdir)/$(NAME).a
	@rm -rf $(DESTDIR)$(includedir)/sml

=== debian/changelog ===
libsml (1.1.2-2) unstable; urgency=medium

  * Source-only upload 

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Sun, 14 Jan 2024 19:57:50 +0100

libsml (1.1.2-1) unstable; urgency=medium

  * Added the libsml-utils package containing the sml_server utility  

 -- Joachim Zobel <jz-2017@heute-morgen.de>  Sat, 13 Jan 2024 10:53:14 +0100

=== debian/control ===
Source: libsml
Priority: optional
Maintainer: Joachim Zobel <jz-2017@heute-morgen.de>
Build-Depends: debhelper-compat (= 13), uuid-dev (>= 2.16), dh-exec, pandoc
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://github.com/volkszaehler/libsml
Vcs-Git: https://github.com/volkszaehler/libsml.git
Vcs-Browser: https://github.com/volkszaehler/libsml

Package: libsml-dev
Section: libdevel
Architecture: any
Depends: libsml1 (= ${binary:Version}), uuid-dev (>= 2.16), ${misc:Depends}
Multi-Arch: same
Description: Header files for libSML
 libSML is a library which implements the Smart Messaging Language (SML)
 protocol specified by VDE's Forum Netztechnik/Netzbetrieb (FNN).
 It can be utilized to communicate to FNN specified Smart Meters
 or Smart Meter components (EDL/MUC).
 .
 This package includes header include files and an example for libSML

Package: libsml1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libsml-utils
Multi-Arch: same
Description: Library for the Smart Messaging Language (SML)
 libSML is a library which implements the Smart Messaging Language (SML)
 protocol specified by VDE's Forum Netztechnik/Netzbetrieb (FNN).
 It can be utilized to communicate to FNN specified Smart Meters
 or Smart Meter components (EDL/MUC).

Package: libsml-utils 
Architecture: any
Depends: libsml1, ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Small tool for testing and debugging libsml
 sml_server was originally intended as an example but is quite useful by itself.

=== debian/rules ===
#!/usr/bin/make -f

# Build with all available hardening options
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

VERSION=$(shell dpkg-parsechangelog --show-field Version 2>/dev/null | cut -f1 -d-)

execute_before_dh_auto_build:
	sed -i 's#"version":.*#"version": "${VERSION}",#' library.json 
	sed -i 's#Version:.*#Version: ${VERSION}#' sml.pc

execute_after_dh_auto_build:
	pandoc -o sml_server.1 -s -t man debian/sml_server.1.md

execute_after_dh_clean:
	rm -f sml_server.1

override_dh_auto_install:

%:
	dh $@

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?([\.\d]+)\.tar\.gz/libsml-$1\.tar\.gz/,\
downloadurlmangle=s/archive\/refs\/tags\/v([\.\d]+)\.tar\.gz/releases\/download\/v$1\/libsml-$1\.tar\.gz/ \
  https://github.com/volkszaehler/libsml/tags .*/v?([\.\d]+)\.tar\.gz
